All of lore.kernel.org
 help / color / mirror / Atom feed
* [PATCH] xfstests: add test for ext4 fallocate collapse range check
@ 2014-06-19  5:50 Xing Gu
  2014-06-19  6:56 ` Dave Chinner
                   ` (3 more replies)
  0 siblings, 4 replies; 9+ messages in thread
From: Xing Gu @ 2014-06-19  5:50 UTC (permalink / raw)
  To: fstests; +Cc: Xing Gu

This is a test to verify the procedure which checks whether
offset + len is bigger than i_size is removed from do_fallocate
in collapse range to the file system, and ensure that i_size is
not going to change.

Signed-off-by: Xing Gu <gux.fnst@cn.fujitsu.com>
---
 tests/ext4/307     | 80 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/ext4/307.out |  1 +
 tests/ext4/group   |  1 +
 3 files changed, 82 insertions(+)
 create mode 100755 tests/ext4/307
 create mode 100644 tests/ext4/307.out

diff --git a/tests/ext4/307 b/tests/ext4/307
new file mode 100755
index 0000000..595c7c1
--- /dev/null
+++ b/tests/ext4/307
@@ -0,0 +1,80 @@
+#! /bin/bash
+# FS QA Test No. 307
+#
+# Regression test for commit:
+# 23fffa9 fs: move falloc collapse range check into the filesystem methods
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2014 Fujitsu.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+PIDS=""
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	kill $PIDS >/dev/null 2>&1
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs ext4
+_supported_os Linux
+_require_scratch
+_require_xfs_io_command "fcollapse"
+
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount
+
+old_bug=`dmesg | grep -c "kernel BUG"`
+
+testfile=$SCRATCH_MNT/file.$seq
+# fcollapse/truncate continuously and simultaneously
+# a same file
+for ((i=1; i <= 100; i++))
+do
+	while true;do
+		$XFS_IO_PROG -f -c 'truncate 100k' $testfile 2>> $seqres.full
+		$XFS_IO_PROG -f -c 'fcollapse 0 16k' $testfile 2>> $seqres.full
+	done &
+	PIDS="$PIDS $!"
+	while true;do
+		$XFS_IO_PROG -f -c 'truncate 0' $testfile 2>> $seqres.full
+	done &
+	PIDS="$PIDS $!"
+done
+# sleep for 180s, BUG_ON is triggered within 3 minutes
+# in most case
+sleep 180
+
+new_bug=`dmesg | grep -c "kernel BUG"`
+if [ $new_bug -ne $old_bug ]; then
+	echo "kernel bug detected, check dmesg for more infomation."
+fi
+
+kill $PIDS >/dev/null 2>&1
+wait
+status=0
+exit
diff --git a/tests/ext4/307.out b/tests/ext4/307.out
new file mode 100644
index 0000000..260c17c
--- /dev/null
+++ b/tests/ext4/307.out
@@ -0,0 +1 @@
+QA output created by 307
diff --git a/tests/ext4/group b/tests/ext4/group
index 7e66035..0f1852f 100644
--- a/tests/ext4/group
+++ b/tests/ext4/group
@@ -12,3 +12,4 @@
 304 aio dangerous ioctl rw stress
 305 auto
 306 auto rw resize quick
+307 auto
-- 
1.9.3


^ permalink raw reply related	[flat|nested] 9+ messages in thread

* Re: [PATCH] xfstests: add test for ext4 fallocate collapse range check
  2014-06-19  5:50 [PATCH] xfstests: add test for ext4 fallocate collapse range check Xing Gu
@ 2014-06-19  6:56 ` Dave Chinner
  2014-06-25 10:05   ` gux.fnst
  2014-06-19  9:12 ` Lukáš Czerner
                   ` (2 subsequent siblings)
  3 siblings, 1 reply; 9+ messages in thread
From: Dave Chinner @ 2014-06-19  6:56 UTC (permalink / raw)
  To: Xing Gu; +Cc: fstests

On Thu, Jun 19, 2014 at 01:50:04PM +0800, Xing Gu wrote:
> This is a test to verify the procedure which checks whether
> offset + len is bigger than i_size is removed from do_fallocate
> in collapse range to the file system, and ensure that i_size is
> not going to change.
> 
> Signed-off-by: Xing Gu <gux.fnst@cn.fujitsu.com>

Does the test really need 3 minutes?

We can't keep adding tests that take minutes to *maybe* hit a
regression. This isn't even testing a regression - the
COLLAPSE_RANGE feature was introduced in 3.15-rc1 and this bug fixed
in 3.15-rc3, so there are no kernels out there that have this
bug in them.

IOWs, I really don't think we should be the runtime of a typical
test cycle by 5% to exercise this non-bug. Maybe 30s at most, but a
shorter, directly targeted test would be better.

And FWIW, there's nothing ext4 specific about this test - it should
be in the generic group if we are going to add it.

Cheers,

Dave.
-- 
Dave Chinner
david@fromorbit.com

^ permalink raw reply	[flat|nested] 9+ messages in thread

* Re: [PATCH] xfstests: add test for ext4 fallocate collapse range check
  2014-06-19  5:50 [PATCH] xfstests: add test for ext4 fallocate collapse range check Xing Gu
  2014-06-19  6:56 ` Dave Chinner
@ 2014-06-19  9:12 ` Lukáš Czerner
  2014-06-25 10:05   ` gux.fnst
  2014-09-17 10:03 ` [PATCH v2] xfstests: add test for truncate/collapse range race Xing Gu
  2014-09-30  9:50 ` [PATCH v3] " Xing Gu
  3 siblings, 1 reply; 9+ messages in thread
From: Lukáš Czerner @ 2014-06-19  9:12 UTC (permalink / raw)
  To: Xing Gu; +Cc: fstests

On Thu, 19 Jun 2014, Xing Gu wrote:

> Date: Thu, 19 Jun 2014 13:50:04 +0800
> From: Xing Gu <gux.fnst@cn.fujitsu.com>
> To: fstests@vger.kernel.org
> Cc: Xing Gu <gux.fnst@cn.fujitsu.com>
> Subject: [PATCH] xfstests: add test for ext4 fallocate collapse range check
> 
> This is a test to verify the procedure which checks whether
> offset + len is bigger than i_size is removed from do_fallocate
> in collapse range to the file system, and ensure that i_size is
> not going to change.
> 
> Signed-off-by: Xing Gu <gux.fnst@cn.fujitsu.com>
> ---
>  tests/ext4/307     | 80 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/ext4/307.out |  1 +
>  tests/ext4/group   |  1 +
>  3 files changed, 82 insertions(+)
>  create mode 100755 tests/ext4/307
>  create mode 100644 tests/ext4/307.out
> 
> diff --git a/tests/ext4/307 b/tests/ext4/307
> new file mode 100755
> index 0000000..595c7c1
> --- /dev/null
> +++ b/tests/ext4/307
> @@ -0,0 +1,80 @@
> +#! /bin/bash
> +# FS QA Test No. 307
> +#
> +# Regression test for commit:
> +# 23fffa9 fs: move falloc collapse range check into the filesystem methods

The check is the same but it's in a different place. Also why is this
ext4 specific ? Also you're testing a race, not this commit .. see
below.

> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2014 Fujitsu.  All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
> +#-----------------------------------------------------------------------
> +#
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +PIDS=""
> +status=1	# failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +	kill $PIDS >/dev/null 2>&1
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +# real QA test starts here
> +_supported_fs ext4
> +_supported_os Linux
> +_require_scratch
> +_require_xfs_io_command "fcollapse"
> +
> +_scratch_mkfs > $seqres.full 2>&1
> +_scratch_mount
> +
> +old_bug=`dmesg | grep -c "kernel BUG"`
> +
> +testfile=$SCRATCH_MNT/file.$seq
> +# fcollapse/truncate continuously and simultaneously
> +# a same file
> +for ((i=1; i <= 100; i++))
> +do
> +	while true;do
> +		$XFS_IO_PROG -f -c 'truncate 100k' $testfile 2>> $seqres.full
> +		$XFS_IO_PROG -f -c 'fcollapse 0 16k' $testfile 2>> $seqres.full
> +	done &
> +	PIDS="$PIDS $!"
> +	while true;do
> +		$XFS_IO_PROG -f -c 'truncate 0' $testfile 2>> $seqres.full
> +	done &
> +	PIDS="$PIDS $!"

It does not look like it's just checking whether we correctly bail
out if collapse range ends past i_size, but rather it's checking for
the truncate/collapse range race.

Also in description you're saying that we need to make sure that
i_size is not going to change, which is not tested here at all.

So I think that you need to split it in two tests:

 - test truncate/collapse range race (what is the failure
   condition?)
 - test whether we correctly bail out when collapse range is past
   i_size and make sure that i_size did not change at all.

Thanks!
-Lukas

> +done
> +# sleep for 180s, BUG_ON is triggered within 3 minutes
> +# in most case
> +sleep 180
> +
> +new_bug=`dmesg | grep -c "kernel BUG"`
> +if [ $new_bug -ne $old_bug ]; then
> +	echo "kernel bug detected, check dmesg for more infomation."
> +fi
> +
> +kill $PIDS >/dev/null 2>&1
> +wait
> +status=0
> +exit
> diff --git a/tests/ext4/307.out b/tests/ext4/307.out
> new file mode 100644
> index 0000000..260c17c
> --- /dev/null
> +++ b/tests/ext4/307.out
> @@ -0,0 +1 @@
> +QA output created by 307
> diff --git a/tests/ext4/group b/tests/ext4/group
> index 7e66035..0f1852f 100644
> --- a/tests/ext4/group
> +++ b/tests/ext4/group
> @@ -12,3 +12,4 @@
>  304 aio dangerous ioctl rw stress
>  305 auto
>  306 auto rw resize quick
> +307 auto
> 

^ permalink raw reply	[flat|nested] 9+ messages in thread

* Re: [PATCH] xfstests: add test for ext4 fallocate collapse range check
  2014-06-19  9:12 ` Lukáš Czerner
@ 2014-06-25 10:05   ` gux.fnst
  0 siblings, 0 replies; 9+ messages in thread
From: gux.fnst @ 2014-06-25 10:05 UTC (permalink / raw)
  To: Lukáš Czerner, Dave Chinner; +Cc: fstests



On 06/19/2014 05:12 PM, Lukáš Czerner wrote:
> On Thu, 19 Jun 2014, Xing Gu wrote:
>
>> Date: Thu, 19 Jun 2014 13:50:04 +0800
>> From: Xing Gu <gux.fnst@cn.fujitsu.com>
>> To: fstests@vger.kernel.org
>> Cc: Xing Gu <gux.fnst@cn.fujitsu.com>
>> Subject: [PATCH] xfstests: add test for ext4 fallocate collapse range check
>>
>> +
>> +testfile=$SCRATCH_MNT/file.$seq
>> +# fcollapse/truncate continuously and simultaneously
>> +# a same file
>> +for ((i=1; i <= 100; i++))
>> +do
>> +	while true;do
>> +		$XFS_IO_PROG -f -c 'truncate 100k' $testfile 2>> $seqres.full
>> +		$XFS_IO_PROG -f -c 'fcollapse 0 16k' $testfile 2>> $seqres.full
>> +	done &
>> +	PIDS="$PIDS $!"
>> +	while true;do
>> +		$XFS_IO_PROG -f -c 'truncate 0' $testfile 2>> $seqres.full
>> +	done &
>> +	PIDS="$PIDS $!"
>
> It does not look like it's just checking whether we correctly bail
> out if collapse range ends past i_size, but rather it's checking for
> the truncate/collapse range race.
>
> Also in description you're saying that we need to make sure that
> i_size is not going to change, which is not tested here at all.
>
> So I think that you need to split it in two tests:
>
>   - test truncate/collapse range race (what is the failure
>     condition?)
>   - test whether we correctly bail out when collapse range is past
>     i_size and make sure that i_size did not change at all.


Indeed, this case is not ext4 specific, and just checks for the 
truncate/collapse range race.
If this case is needed by xfstests, I will modify the classification and 
description of this case according to your comment.

Thanks for your review!

Regards,
Xing Gu


>
> Thanks!
> -Lukas
>
>> +done
>> +# sleep for 180s, BUG_ON is triggered within 3 minutes
>> +# in most case
>> +sleep 180
>> +
>> +new_bug=`dmesg | grep -c "kernel BUG"`
>> +if [ $new_bug -ne $old_bug ]; then
>> +	echo "kernel bug detected, check dmesg for more infomation."
>> +fi
>> +
>> +kill $PIDS >/dev/null 2>&1
>> +wait
>> +status=0
>> +exit
>> diff --git a/tests/ext4/307.out b/tests/ext4/307.out
>> new file mode 100644
>> index 0000000..260c17c
>> --- /dev/null
>> +++ b/tests/ext4/307.out
>> @@ -0,0 +1 @@
>> +QA output created by 307
>> diff --git a/tests/ext4/group b/tests/ext4/group
>> index 7e66035..0f1852f 100644
>> --- a/tests/ext4/group
>> +++ b/tests/ext4/group
>> @@ -12,3 +12,4 @@
>>   304 aio dangerous ioctl rw stress
>>   305 auto
>>   306 auto rw resize quick
>> +307 auto
>>
> .
>

^ permalink raw reply	[flat|nested] 9+ messages in thread

* Re: [PATCH] xfstests: add test for ext4 fallocate collapse range check
  2014-06-19  6:56 ` Dave Chinner
@ 2014-06-25 10:05   ` gux.fnst
  0 siblings, 0 replies; 9+ messages in thread
From: gux.fnst @ 2014-06-25 10:05 UTC (permalink / raw)
  To: Dave Chinner, Lukáš Czerner; +Cc: fstests



On 06/19/2014 02:56 PM, Dave Chinner wrote:
> On Thu, Jun 19, 2014 at 01:50:04PM +0800, Xing Gu wrote:
>> This is a test to verify the procedure which checks whether
>> offset + len is bigger than i_size is removed from do_fallocate
>> in collapse range to the file system, and ensure that i_size is
>> not going to change.
>>
>> Signed-off-by: Xing Gu <gux.fnst@cn.fujitsu.com>
>
> Does the test really need 3 minutes?

Actually, this case can easily reproduce the issue below 30s.

>
> We can't keep adding tests that take minutes to *maybe* hit a
> regression. This isn't even testing a regression - the
> COLLAPSE_RANGE feature was introduced in 3.15-rc1 and this bug fixed
> in 3.15-rc3, so there are no kernels out there that have this
> bug in them.
>
> IOWs, I really don't think we should be the runtime of a typical
> test cycle by 5% to exercise this non-bug. Maybe 30s at most, but a
> shorter, directly targeted test would be better.
>
> And FWIW, there's nothing ext4 specific about this test - it should
> be in the generic group if we are going to add it.

Indeed, it's not ext4 specific.

What about modifying this case according to Lukas's comment?

Thanks!

Regards,
Xing Gu

>
> Cheers,
>
> Dave.
>

^ permalink raw reply	[flat|nested] 9+ messages in thread

* [PATCH v2] xfstests: add test for truncate/collapse range race
  2014-06-19  5:50 [PATCH] xfstests: add test for ext4 fallocate collapse range check Xing Gu
  2014-06-19  6:56 ` Dave Chinner
  2014-06-19  9:12 ` Lukáš Czerner
@ 2014-09-17 10:03 ` Xing Gu
  2014-09-25  3:55   ` Eryu Guan
  2014-09-30  9:50 ` [PATCH v3] " Xing Gu
  3 siblings, 1 reply; 9+ messages in thread
From: Xing Gu @ 2014-09-17 10:03 UTC (permalink / raw)
  To: fstests; +Cc: Xing Gu

This case tests truncate/collapse range race. If
the race occurs, it will trigger BUG_ON.

Signed-off-by: Xing Gu <gux.fnst@cn.fujitsu.com>
---
 tests/generic/326     | 76 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/326.out |  1 +
 tests/generic/group   |  1 +
 3 files changed, 78 insertions(+)
 create mode 100755 tests/generic/326
 create mode 100644 tests/generic/326.out

diff --git a/tests/generic/326 b/tests/generic/326
new file mode 100755
index 0000000..8a66180
--- /dev/null
+++ b/tests/generic/326
@@ -0,0 +1,76 @@
+#! /bin/bash
+# FS QA Test No. 326
+#
+# Test truncate/collapse range race.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2014 Fujitsu.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+
+_cleanup()
+{
+    rm -f $tmp.*
+}
+
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_os Linux
+_require_scratch
+_require_xfs_io_command "fcollapse"
+
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount
+
+old_bug=`dmesg | grep -c "kernel BUG"`
+
+testfile=$SCRATCH_MNT/file.$seq
+# fcollapse/truncate continuously and simultaneously
+# a same file
+for ((i=1; i <= 100; i++))
+do
+	for ((i=1; i <= 1000; i++))
+	do
+		$XFS_IO_PROG -f -c 'truncate 100k' $testfile 2>> $seqres.full
+		$XFS_IO_PROG -f -c 'fcollapse 0 16k' $testfile 2>> $seqres.full
+	done &
+	for ((i=1; i <= 1000; i++))
+	do
+		$XFS_IO_PROG -f -c 'truncate 0' $testfile 2>> $seqres.full
+	done &
+done
+
+wait
+
+new_bug=`dmesg | grep -c "kernel BUG"`
+if [ $new_bug -ne $old_bug ]; then
+	echo "kernel bug detected, check dmesg for more infomation."
+fi
+
+status=0 ; exit
diff --git a/tests/generic/326.out b/tests/generic/326.out
new file mode 100644
index 0000000..90a76cc
--- /dev/null
+++ b/tests/generic/326.out
@@ -0,0 +1 @@
+QA output created by 326
diff --git a/tests/generic/group b/tests/generic/group
index bdcfd9d..b690f5c 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -145,3 +145,4 @@
 323 auto aio stress
 324 auto fsr quick
 325 auto quick data log
+326 auto
-- 
1.9.3


^ permalink raw reply related	[flat|nested] 9+ messages in thread

* Re: [PATCH v2] xfstests: add test for truncate/collapse range race
  2014-09-17 10:03 ` [PATCH v2] xfstests: add test for truncate/collapse range race Xing Gu
@ 2014-09-25  3:55   ` Eryu Guan
  0 siblings, 0 replies; 9+ messages in thread
From: Eryu Guan @ 2014-09-25  3:55 UTC (permalink / raw)
  To: Xing Gu; +Cc: fstests

On Wed, Sep 17, 2014 at 06:03:00PM +0800, Xing Gu wrote:
> This case tests truncate/collapse range race. If
> the race occurs, it will trigger BUG_ON.
> 
> Signed-off-by: Xing Gu <gux.fnst@cn.fujitsu.com>
> ---
>  tests/generic/326     | 76 +++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/generic/326.out |  1 +
>  tests/generic/group   |  1 +
>  3 files changed, 78 insertions(+)
>  create mode 100755 tests/generic/326
>  create mode 100644 tests/generic/326.out
> 
> diff --git a/tests/generic/326 b/tests/generic/326
> new file mode 100755
> index 0000000..8a66180
> --- /dev/null
> +++ b/tests/generic/326
> @@ -0,0 +1,76 @@
> +#! /bin/bash
> +# FS QA Test No. 326
> +#
> +# Test truncate/collapse range race.
> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2014 Fujitsu.  All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
> +#-----------------------------------------------------------------------
> +#
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1	# failure is the default!
> +
> +_cleanup()
> +{
> +    rm -f $tmp.*
> +}
> +
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +# real QA test starts here
> +_supported_os Linux

Missing "_supported_fs generic" here.

Thanks,
Eryu
> +_require_scratch
> +_require_xfs_io_command "fcollapse"
> +
> +_scratch_mkfs > $seqres.full 2>&1
> +_scratch_mount
> +
> +old_bug=`dmesg | grep -c "kernel BUG"`
> +
> +testfile=$SCRATCH_MNT/file.$seq
> +# fcollapse/truncate continuously and simultaneously
> +# a same file
> +for ((i=1; i <= 100; i++))
> +do
> +	for ((i=1; i <= 1000; i++))
> +	do
> +		$XFS_IO_PROG -f -c 'truncate 100k' $testfile 2>> $seqres.full
> +		$XFS_IO_PROG -f -c 'fcollapse 0 16k' $testfile 2>> $seqres.full
> +	done &
> +	for ((i=1; i <= 1000; i++))
> +	do
> +		$XFS_IO_PROG -f -c 'truncate 0' $testfile 2>> $seqres.full
> +	done &
> +done
> +
> +wait
> +
> +new_bug=`dmesg | grep -c "kernel BUG"`
> +if [ $new_bug -ne $old_bug ]; then
> +	echo "kernel bug detected, check dmesg for more infomation."
> +fi
> +
> +status=0 ; exit
> diff --git a/tests/generic/326.out b/tests/generic/326.out
> new file mode 100644
> index 0000000..90a76cc
> --- /dev/null
> +++ b/tests/generic/326.out
> @@ -0,0 +1 @@
> +QA output created by 326
> diff --git a/tests/generic/group b/tests/generic/group
> index bdcfd9d..b690f5c 100644
> --- a/tests/generic/group
> +++ b/tests/generic/group
> @@ -145,3 +145,4 @@
>  323 auto aio stress
>  324 auto fsr quick
>  325 auto quick data log
> +326 auto
> -- 
> 1.9.3
> 
> --
> To unsubscribe from this list: send the line "unsubscribe fstests" in
> the body of a message to majordomo@vger.kernel.org
> More majordomo info at  http://vger.kernel.org/majordomo-info.html

^ permalink raw reply	[flat|nested] 9+ messages in thread

* [PATCH v3] xfstests: add test for truncate/collapse range race
  2014-06-19  5:50 [PATCH] xfstests: add test for ext4 fallocate collapse range check Xing Gu
                   ` (2 preceding siblings ...)
  2014-09-17 10:03 ` [PATCH v2] xfstests: add test for truncate/collapse range race Xing Gu
@ 2014-09-30  9:50 ` Xing Gu
  2014-10-22  9:56   ` gux.fnst
  3 siblings, 1 reply; 9+ messages in thread
From: Xing Gu @ 2014-09-30  9:50 UTC (permalink / raw)
  To: fstests; +Cc: Xing Gu

This case tests truncate/collapse range race. If
the race occurs, it will trigger BUG_ON.

Signed-off-by: Xing Gu <gux.fnst@cn.fujitsu.com>
---
 tests/generic/326     | 77 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/326.out |  1 +
 tests/generic/group   |  1 +
 3 files changed, 79 insertions(+)
 create mode 100755 tests/generic/326
 create mode 100644 tests/generic/326.out

diff --git a/tests/generic/326 b/tests/generic/326
new file mode 100755
index 0000000..c24e3ba
--- /dev/null
+++ b/tests/generic/326
@@ -0,0 +1,77 @@
+#! /bin/bash
+# FS QA Test No. 326
+#
+# Test truncate/collapse range race.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2014 Fujitsu.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+
+_cleanup()
+{
+    rm -f $tmp.*
+}
+
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_os Linux
+_supported_fs generic
+_require_scratch
+_require_xfs_io_command "fcollapse"
+
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount
+
+old_bug=`dmesg | grep -c "kernel BUG"`
+
+testfile=$SCRATCH_MNT/file.$seq
+# fcollapse/truncate continuously and simultaneously
+# a same file
+for ((i=1; i <= 100; i++))
+do
+	for ((i=1; i <= 1000; i++))
+	do
+		$XFS_IO_PROG -f -c 'truncate 100k' $testfile 2>> $seqres.full
+		$XFS_IO_PROG -f -c 'fcollapse 0 16k' $testfile 2>> $seqres.full
+	done &
+	for ((i=1; i <= 1000; i++))
+	do
+		$XFS_IO_PROG -f -c 'truncate 0' $testfile 2>> $seqres.full
+	done &
+done
+
+wait
+
+new_bug=`dmesg | grep -c "kernel BUG"`
+if [ $new_bug -ne $old_bug ]; then
+	echo "kernel bug detected, check dmesg for more infomation."
+fi
+
+status=0 ; exit
diff --git a/tests/generic/326.out b/tests/generic/326.out
new file mode 100644
index 0000000..90a76cc
--- /dev/null
+++ b/tests/generic/326.out
@@ -0,0 +1 @@
+QA output created by 326
diff --git a/tests/generic/group b/tests/generic/group
index 799bfd8..5ef8acb 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -151,3 +151,4 @@
 323 auto aio stress
 324 auto fsr quick
 325 auto quick data log
+326 auto
-- 
1.9.3


^ permalink raw reply related	[flat|nested] 9+ messages in thread

* Re: [PATCH v3] xfstests: add test for truncate/collapse range race
  2014-09-30  9:50 ` [PATCH v3] " Xing Gu
@ 2014-10-22  9:56   ` gux.fnst
  0 siblings, 0 replies; 9+ messages in thread
From: gux.fnst @ 2014-10-22  9:56 UTC (permalink / raw)
  To: Dave Chinner; +Cc: fstests

Hi, Dave

    I'd like to know whether this test case is meaningful for xfstests.
If it is not, I will drop it.
    Thanks!

Regards,
Xing Gu

On 09/30/2014 05:50 PM, Xing Gu wrote:
> This case tests truncate/collapse range race. If
> the race occurs, it will trigger BUG_ON.
> 
> Signed-off-by: Xing Gu <gux.fnst@cn.fujitsu.com>
> ---
>   tests/generic/326     | 77 +++++++++++++++++++++++++++++++++++++++++++++++++++
>   tests/generic/326.out |  1 +
>   tests/generic/group   |  1 +
>   3 files changed, 79 insertions(+)
>   create mode 100755 tests/generic/326
>   create mode 100644 tests/generic/326.out
> 
> diff --git a/tests/generic/326 b/tests/generic/326
> new file mode 100755
> index 0000000..c24e3ba
> --- /dev/null
> +++ b/tests/generic/326
> @@ -0,0 +1,77 @@
> +#! /bin/bash
> +# FS QA Test No. 326
> +#
> +# Test truncate/collapse range race.
> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2014 Fujitsu.  All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
> +#-----------------------------------------------------------------------
> +#
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1	# failure is the default!
> +
> +_cleanup()
> +{
> +    rm -f $tmp.*
> +}
> +
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +# real QA test starts here
> +_supported_os Linux
> +_supported_fs generic
> +_require_scratch
> +_require_xfs_io_command "fcollapse"
> +
> +_scratch_mkfs > $seqres.full 2>&1
> +_scratch_mount
> +
> +old_bug=`dmesg | grep -c "kernel BUG"`
> +
> +testfile=$SCRATCH_MNT/file.$seq
> +# fcollapse/truncate continuously and simultaneously
> +# a same file
> +for ((i=1; i <= 100; i++))
> +do
> +	for ((i=1; i <= 1000; i++))
> +	do
> +		$XFS_IO_PROG -f -c 'truncate 100k' $testfile 2>> $seqres.full
> +		$XFS_IO_PROG -f -c 'fcollapse 0 16k' $testfile 2>> $seqres.full
> +	done &
> +	for ((i=1; i <= 1000; i++))
> +	do
> +		$XFS_IO_PROG -f -c 'truncate 0' $testfile 2>> $seqres.full
> +	done &
> +done
> +
> +wait
> +
> +new_bug=`dmesg | grep -c "kernel BUG"`
> +if [ $new_bug -ne $old_bug ]; then
> +	echo "kernel bug detected, check dmesg for more infomation."
> +fi
> +
> +status=0 ; exit
> diff --git a/tests/generic/326.out b/tests/generic/326.out
> new file mode 100644
> index 0000000..90a76cc
> --- /dev/null
> +++ b/tests/generic/326.out
> @@ -0,0 +1 @@
> +QA output created by 326
> diff --git a/tests/generic/group b/tests/generic/group
> index 799bfd8..5ef8acb 100644
> --- a/tests/generic/group
> +++ b/tests/generic/group
> @@ -151,3 +151,4 @@
>   323 auto aio stress
>   324 auto fsr quick
>   325 auto quick data log
> +326 auto
> 

^ permalink raw reply	[flat|nested] 9+ messages in thread

end of thread, other threads:[~2014-10-22  9:59 UTC | newest]

Thread overview: 9+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2014-06-19  5:50 [PATCH] xfstests: add test for ext4 fallocate collapse range check Xing Gu
2014-06-19  6:56 ` Dave Chinner
2014-06-25 10:05   ` gux.fnst
2014-06-19  9:12 ` Lukáš Czerner
2014-06-25 10:05   ` gux.fnst
2014-09-17 10:03 ` [PATCH v2] xfstests: add test for truncate/collapse range race Xing Gu
2014-09-25  3:55   ` Eryu Guan
2014-09-30  9:50 ` [PATCH v3] " Xing Gu
2014-10-22  9:56   ` gux.fnst

This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.